

function urlencode(str)
{
  return escape(str).replace(/\+/g,'%2B').replace(/%20/g, '+').replace(/\*/g, '%2A').replace(/\//g, '%2F').replace(/@/g, '%40');
}

function urldecode(str)
{
  return unescape(str.replace('+', ' '));
}

function addslashes(str)
{
  return (str+'').replace(/[\\"']/g, '\\$&').replace(/\u0000/g, '\\0');
}

// Test if the plugin is present on the system
function ScolInstalled()
{
  var pluginBloc = 0;
  
  // mozilla compatible mode
  if(navigator.plugins&&navigator.mimeTypes&&navigator.mimeTypes.length)
  {
    pluginBloc = document.createElement('embed');
    pluginBloc.type = 'application/x-scol';
  }
  else
  {
    pluginBloc = document.createElement('object');
    pluginBloc.setAttribute('classid', 'clsid:7A96FF35-4937-11D1-8F2C-00609779BDA3');
  }
  
  pluginBloc.width = '1';
  pluginBloc.height = '1';
  pluginBloc.id = 'lms3d_plugin_test';
  pluginBloc.name = 'lms3d_plugin_test';
  
  document.body.appendChild(pluginBloc);
  
  try
  {
    //test a plugin function
    pluginBloc.LaunchMachine('', 0, 0);
    document.body.removeChild(pluginBloc);
    return true;
  }
  catch(err)
  {
    document.body.removeChild(pluginBloc);
    return false;
  }
}

function scolEnd()
{
  //Your code here
}

function errorFromScol(div, dlurl, error)
{
  var n=document.getElementById(div);
  n.innerHTML="<div style=\"background-color:#ffffff; text-align:center;\">The Scol Voyager plugin is not detected, please download it and install from <a href=\"" + dlurl + "\">" + dlurl + "</a></div>";
}

function messageFromScol(msg)
{
  // manage call formated with "keyword param"
  // get first word
  // Warning IE doesn't return the same result as others
  var reg = /^([A-Z0-9]*) ([?]*)/im;
  var word = msg.match(reg);
  
  var param ="";
  if (word)
  {
    //IE !!
    var keyword = word[0];
    //IE force trimm !!
    keyword = keyword.replace(/^\s+|\s+$/g,"");
    
    //Get param value
    param = msg.slice(keyword.length);
    switch (keyword)
    {
    case "OS3DPlayerLoading":
      break;
    case "OS3DPlayerError":
      break;
    //try to execute msg as JS code
    default:
      eval(msg);
    }
  }
  //try to execute msg as JS code
  else eval(msg);
}

if(typeof scolob=="undefined"){var scolob=new Object();}

scolob.SCOLObject=
  function(id, url, pluginUrl, scolversion, width, height, external, messagecb, errorcb, endcb)
  {
    if(!document.getElementById)
    {
      return;
    }
    
    messagecb = (messagecb)? messagecb:"messageFromScol";
    endcb = (endcb)? endcb:"scolEnd";
    
    this.ErrorCb = (errorcb)? errorcb:"errorFromScol";
    this.LastError = 0;
    this.DIV = "";
    this.EXTERNAL = external;
    this.PLUGIN_URL = pluginUrl;
    this.URL = url;
    
    this.pluginBloc = 0;
        
    // mozilla compatible mode
    if(navigator.plugins&&navigator.mimeTypes&&navigator.mimeTypes.length)
    {
      this.pluginBloc = document.createElement('embed');
      this.pluginBloc.type = 'application/x-scol';
      
      if(pluginUrl)
      {
        this.pluginBloc.setAttribute('codebase', pluginUrl);
      }
      
      if(scolversion)
      {
        this.pluginBloc.setAttribute('ScolVersionNeeded', scolversion);
      }
    
      this.pluginBloc.setAttribute('ForceInstall', 'no');
        
      this.pluginBloc.setAttribute('onScolMessage', messagecb);
      this.pluginBloc.setAttribute('onScolEnd', endcb);
    }
    else
    {
      this.pluginBloc = document.createElement('object');
      this.pluginBloc.setAttribute('classid', 'clsid:7A96FF35-4937-11D1-8F2C-00609779BDA3');
      
      // CALLBACKS FOR IE
      var msgScrpt = document.createElement('script');
      msgScrpt.setAttribute('FOR', id);
      msgScrpt.setAttribute('EVENT', 'onScolMessage(msg)');
      //method for IE7/8
      msgScrpt.text = messagecb + '(msg);';
      document.body.appendChild(msgScrpt);      
      
      var endScrpt = document.createElement('script');
      endScrpt.setAttribute('FOR', id);
      endScrpt.setAttribute('EVENT', 'onScolEnd');
      endScrpt.text = endcb + '(msg);';
      document.body.appendChild(endScrpt);
      
      if(pluginUrl)
      {
        var objparam1 = document.createElement('param');
        objparam1.name = 'codebase';
        objparam1.value = pluginUrl;
        this.pluginBloc.appendChild(objparam1);
      }

      if(scolversion)
      {
        var objparam2 = document.createElement('param');
        objparam2.name = 'ScolVersionNeeded';
        objparam2.value = scolversion;
        this.pluginBloc.appendChild(objparam2);
      }
      
      var objparam3 = document.createElement('param');
      objparam3.name = 'ForceInstall';
      objparam3.value = 'no';
      this.pluginBloc.appendChild(objparam3);
      
      var objparam3 = document.createElement('param');
      objparam3.name = 'onScolMessage';
      objparam3.value = messagecb;
      this.pluginBloc.appendChild(objparam3);
      
      var objparam4 = document.createElement('param');
      objparam4.name = 'onScolEnd';
      objparam4.value = endcb;
      this.pluginBloc.appendChild(objparam4);
    }
    
    if(width)
    {
      this.pluginBloc.width = width;
    }
    
    if(height)
    {
      this.pluginBloc.height = height;
    }
      
    this.pluginBloc.id = id;
    this.pluginBloc.name = id;
    
    this.pluginBloc.setAttribute('border', '0');
  };


scolob.SCOLObject.prototype=
{
  sendMessage:function(msg, p)
  {
    //document.scol.SendScolMessage('AXMessage "message from browser plugin"');
    //Your code here
    
    if (p)
      this.pluginBloc.SendScolMessage('AXMessage \"' + msg + ' ' + addslashes(p) + '\"'); 
    else
      this.pluginBloc.SendScolMessage('AXMessage \"' + msg + '\"');
  },
  write:function(div)
  {
    this.DIV = div;
    var n = (typeof this.DIV=="string") ? document.getElementById(this.DIV):this.DIV;
    n.appendChild(this.pluginBloc);
  },
  getLastError:function()
  {
    return this.LastError;
  },
  show:function()
  {
    var n = (typeof this.DIV=="string") ? document.getElementById(this.DIV):this.DIV;
    n.style.visibility = 'visible';
  },
  hide:function()
  {
    var n = (typeof this.DIV=="string") ? document.getElementById(this.DIV):this.DIV;
    n.style.visibility = 'hidden';
  },
  setPosition:function(x, y)
  {
    var n = (typeof this.DIV=="string") ? document.getElementById(this.DIV):this.DIV;
    n.style.left = x;
    n.style.top = y;
  },
  setSize:function(w, h)
  {
    var n = (typeof this.DIV=="string") ? document.getElementById(this.DIV):this.DIV;
    n.style.width = w;
    n.style.height = h;
  },
  launch:function(url)
  {
    url = url? url:this.URL;
    try
    {
      if(this.EXTERNAL == 1)
      {
        var ret = this.pluginBloc.LaunchMachine("$browser$%5fload+%22locked%2fstduser%2epkg%22%0amain+%22" + url + "%22+ffffffff+NIL CSDMRWK 1000000",1,0);
        if (ret != 1)
        {
          this.LastError = 2;
          eval(this.ErrorCb + "(\"" + this.DIV + "\", \"" + this.PLUGIN_URL + "\", " + ret + ")");
        }
      }
      // scol script 
      else if(this.EXTERNAL == 2)
      {
        var ret = this.pluginBloc.LaunchMachine("$browser$" + url + "%0a CSDMRWK 1000000",1,0);
        if (ret != 1)
        {
          this.LastError = 2;
          eval(this.ErrorCb + "(\"" + this.DIV + "\", \"" + this.PLUGIN_URL + "\", " + ret + ")");
        }
      }
      else
      {
        var ret = this.pluginBloc.LaunchMachine("$browser$%5fload+%22locked%2flink%2epkg%22%0amain+%22" + url + "%22%0a CSDMRWK 1000000",1,0);
        if (ret != 1)
        {
          this.LastError = 2;
          eval(this.ErrorCb + "(\"" + this.DIV + "\", \"" + this.PLUGIN_URL + "\", " + ret + ")");
        }
      }
    }
    catch(err)
    {
      if(this.DIV)
      {
        if (this.ErrorCb)
        {
          this.LastError = 1;
          eval(this.ErrorCb + "(\"" + this.DIV + "\", \"" + this.PLUGIN_URL + "\", 0)");
        }
        else
        {
          var n = (typeof this.DIV=="string") ? document.getElementById(this.DIV):this.DIV;
          n.innerHTML="<div style=\"background-color:#ffffff; text-align:center;\">The Scol Voyager plugin is not detected, please download it and install from <a href=\"" + this.PLUGIN_URL + "\">" + this.PLUGIN_URL + "</a></div>";
        }
      }
      else
        alert(err);
    }
  }
};

var ScolObject=scolob.SCOLObject;
var SCOLObject=scolob.SCOLObject;